import java.io.*;

public class Baum implements Serializable {
	int wert;
	Baum linkerBaum;  // rekursive Definition: die Klasse Baum enthaelt eine Referenz auf ein Baum-Objekt
	Baum rechterBaum;

	// Konstruktor, die Blaetter l und r muessen null sein (ganz unten im Baum)
	Baum (int w, Baum l, Baum r) {
		wert = w;
		linkerBaum = l;
		rechterBaum = r;
	}
	
	// Getter/Setter
	int getWert() { return wert; }
	void setWert(int w) { wert = w; }
	
	Baum getLinkerBaum()  { return linkerBaum; }
	Baum getRechterBaum() { return rechterBaum; }
	
	void setLinkerBaum(Baum l)  { linkerBaum = l; }
	void setRechterBaum(Baum r) { rechterBaum = r; }
	
	// Baumwerte "inorder" ausgeben
	static void inorderAusgeben(Baum t) {
		if (t.getLinkerBaum() != null)
			inorderAusgeben(t.getLinkerBaum());		// zuerst die kleineren Werte (linken Unterbaum ausgeben, falls nicht leer)
		
		System.out.println(t.getWert() + " ");		// dann den aktuellen Wert ausgeben

		if (t.getRechterBaum() != null)				// am Ende die groesseren Werte (rechten Unterbaum ausgeben, falls nicht leer)
			inorderAusgeben(t.getRechterBaum());
	}
}